<template>
  <el-form
    ref="formRef"
    :model="form"
    :rules="$options.rules"
    label-width="120px"
  >
    <el-form-item label="City From" prop="cityFrom">
      <el-input v-model="form.cityFrom" />
    </el-form-item>
    <el-form-item label="City To" prop="cityTo">
      <el-input v-model="form.cityTo" />
    </el-form-item>
    <el-form-item label="Date of dispatch">
      <el-col :span="11">
        <el-date-picker
          v-model="form.date"
          type="date"
          placeholder="Pick a date"
          style="width: 100%"
        />
      </el-col>
    </el-form-item>
    <el-button type="primary" @click="submitForm($refs.formRef)"
      >Create</el-button
    >
    <ButtonBack />
  </el-form>
</template>

<script>
import axios from 'axios'
export default {
  name: 'CreateOrderForm',
  data() {
    return {
      form: {
        cityFrom: '',
        cityTo: '',
        typeOfParcel: '',
        date: '',
        desc: '',
      },
      requestsList: [],
    }
  },
  rules: {
    cityFrom: [
      {
        required: true,
        message: 'Please input a city from',
        trigger: 'blur',
      },
    ],
    cityTo: [
      {
        required: true,
        message: 'Please input a city to',
        trigger: 'blur',
      },
    ],
  },
  methods: {
    async submitForm(formEl) {
      if (!formEl) return
      await formEl.validate((valid, fields) => {
        if (valid) {
          const newRequest = { ...this.form }
          axios.post('/api/requests', { data: newRequest })
          this.$router.push({
            name: 'requests',
            query: {
              ...this.$route.query,
            },
          })
        } else {
          console.log('error submit!', fields)
        }
      })
    },
  },
}
</script>
